package digital.laboratory.platform.imr.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import digital.laboratory.platform.common.mybatis.security.service.DLPUser;
import digital.laboratory.platform.imr.dto.ApplyDTO;
import digital.laboratory.platform.imr.entity.SampleApply;
import digital.laboratory.platform.imr.vo.SampleApplyVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 检材申请实体类服务类
 *
 * @author Zhang Xiaolong created at  2023-03-17
 * @describe 检材申请实体类 服务类
 */
public interface SampleApplyService extends IService<SampleApply> {


    SampleApplyVO createAndSave(ApplyDTO dto, DLPUser dlpUser);

    SampleApplyVO getDetail(String id);

    SampleApplyVO  createAndSubmit(ApplyDTO dto, DLPUser dlpUser);

    SampleApplyVO submitApplyOne(String id);

    IPage<SampleApplyVO> getApplyPage(Page<SampleApply> page,QueryWrapper<SampleApply> orderByDesc);

    SampleApplyVO withdrawalOne(String id);

    void deleteOne(String id);

    SampleApplyVO updateAndSubmit(ApplyDTO dto, DLPUser dlpUser);

    SampleApplyVO updateAndSave(ApplyDTO dto, DLPUser dlpUser);
}
